diff --git a/gnu/local.mk b/gnu/local.mk
index 3d59e27e8..3bc9d966f 100644
--- a/gnu/local.mk
+++ b/gnu/local.mk
@@ -693,7 +693,6 @@ dist_patch_DATA =						\
   %D%/packages/patches/clementine-use-openssl.patch		\
   %D%/packages/patches/clisp-remove-failing-test.patch		\
   %D%/packages/patches/clucene-pkgconfig.patch			\
-  %D%/packages/patches/clx-remove-demo.patch			\
   %D%/packages/patches/coda-use-system-libs.patch		\
   %D%/packages/patches/combinatorial-blas-awpm.patch		\
   %D%/packages/patches/combinatorial-blas-io-fix.patch		\
diff --git a/gnu/packages/lisp.scm b/gnu/packages/lisp.scm
index 93dc1aaf8..3b0476a0a 100644
--- a/gnu/packages/lisp.scm
+++ b/gnu/packages/lisp.scm
@@ -914,42 +914,29 @@ ANSI-compliant Common Lisp implementations.")
   (sbcl-package->cl-source-package sbcl-cl-unicode))
 
 (define-public sbcl-clx
-  (let ((revision "1")
-        (commit "1c62774b03c1cf3fe6e5cb532df8b14b44c96b95"))
-    (package
-      (name "sbcl-clx")
-      (version (string-append "0.0.0-" revision "." (string-take commit 7)))
-      (source
-       (origin
-         (method git-fetch)
-         (uri
-          (git-reference
-           (url "https://github.com/sharplispers/clx.git")
-           (commit commit)))
-         (sha256
-          (base32 "0qffag03ns52kwq9xjns2qg1yr0bf3ba507iwq5cmx5xz0b0rmjm"))
-         (file-name (string-append "clx-" version "-checkout"))
-         (patches
-          (list
-           (search-patch "clx-remove-demo.patch")))
-         (modules '((guix build utils)))
-         (snippet
-          '(begin
-             ;; These removed files cause the compiled system to crash when
-             ;; loading.
-             (delete-file-recursively "demo")
-             (delete-file "test/trapezoid.lisp")
-             (substitute* "clx.asd"
-               (("\\(:file \"trapezoid\"\\)") ""))
-             #t))))
-      (build-system asdf-build-system/sbcl)
-      (home-page "http://www.cliki.net/portable-clx")
-      (synopsis "X11 client library for Common Lisp")
-      (description "CLX is an X11 client library for Common Lisp.  The code was
+  (package
+   (name "sbcl-clx")
+   (version "0.7.5")
+   (source
+    (origin
+     (method git-fetch)
+     (uri
+      (git-reference
+       (url "https://github.com/sharplispers/clx.git")
+       (commit version)))
+     (sha256
+      (base32 "1vi67z9hpj5rr4xcmfbfwzmlcc0ah7hzhrmfid6lqdkva238v2wf"))
+     (file-name (git-file-name name version))
+     (modules '((guix build utils)))))
+   (build-system asdf-build-system/sbcl)
+   (native-inputs `(("fiasco" ,sbcl-fiasco)))
+   (home-page "http://www.cliki.net/portable-clx")
+   (synopsis "X11 client library for Common Lisp")
+   (description "CLX is an X11 client library for Common Lisp.  The code was
 originally taken from a CMUCL distribution, was modified somewhat in order to
 make it compile and run under SBCL, then a selection of patches were added
 from other CLXes around the net.")
-      (license license:x11))))
+   (license license:x11))))
 
 (define-public cl-clx
   (sbcl-package->cl-source-package sbcl-clx))
diff --git a/gnu/packages/patches/clx-remove-demo.patch b/gnu/packages/patches/clx-remove-demo.patch
deleted file mode 100644
index c5fffea0d..000000000
--- a/gnu/packages/patches/clx-remove-demo.patch
+++ /dev/null
@@ -1,27 +0,0 @@
---- a/clx.asd	2016-02-16 00:06:48.161596976 -0500
-+++ b/clx.asd	2016-02-16 00:06:54.793774658 -0500
-@@ -79,24 +79,6 @@
-                (:file "xtest")
-                (:file "screensaver")
-                (:file "xinerama")))
--     (:module demo
--	      :default-component-class example-source-file
--	      :components
--	      ((:file "bezier")
--	       ;; KLUDGE: this requires "bezier" for proper operation,
--	       ;; but we don't declare that dependency here, because
--	       ;; asdf doesn't load example files anyway.
--	       (:file "beziertest")
--	       (:file "clclock")
--               (:file "clipboard")
--	       (:file "clx-demos")
--	       (:file "gl-test")
--	       ;; FIXME: compiling this generates 30-odd spurious code
--	       ;; deletion notes.  Find out why, and either fix or
--	       ;; workaround the problem.
--	       (:file "mandel")
--	       (:file "menu")
--	       (:file "zoid")))
-      (:module test
- 	      :default-component-class example-source-file
- 	      :components